<template>
  <v-data-table
    @click:row="$emit('click:row', $event)"
    :headers="headers"
    :items="items"
    :options.sync="computedPagination"
    :items-per-page="computedPagination.itemsPerPage"
    :loading="loading"
    :server-items-length="serverItemsLength"
    v-bind="$attrs"
    v-on="$listeners"
    v-model="computedValue"
  >
    <template v-slot:top>
      <slot name="top" />
    </template>
    <template
      v-for="(field, index) in computedFields"
      v-slot:[field.slotName]="{ item }"
    >
      <DTDynamic
        v-if="field.type === 'dynamic'"
        :key="value.id + index"
        :value="item"
        :field="field"
      />
      <component
        v-else
        :key="field.id + index"
        :is="`dt-${field.type}`"
        :value="getNested(item, field.id)"
        :format="field.format"
        :symbol="field.symbol"
      />
    </template>
    <template v-slot:item.actions="{ item }">
      <TableActions :item="item" :actions="actions" />
    </template>
    <template v-slot:expanded-item="{ headers, item }">
      <slot name="expanded-item" :headers="headers" :item="item" />
    </template>
  </v-data-table>
</template>

<script>
import { getNested } from "../utils";
import DTDate from "./fields/DTDate";
import DTCurrency from "./fields/DTCurrency";
import DTText from "./fields/DTText";
import DTIndicator from "./fields/DTIndicator";
import TableActions from "./TableActions.vue";
import DTDynamic from "./fields/DTDynamic.vue";

/**
 * BsTable
 */
export default {
  name: "Table",
  components: {
    "dt-date": DTDate,
    "dt-text": DTText,
    "dt-currency": DTCurrency,
    "dt-indicator": DTIndicator,
    DTDynamic,
    TableActions
  },
  props: {
    /**
     * Table items
     */
    items: {
      type: Array,
      default: () => []
    },
    /**
      * Table columns
      *
      fieldName:{
        option: value
      }
      *
      *###Options
      *
      *- **type**: the field type, possible value: text, number, email, password, date, time, dateTime, relation, group
      *
      *- **label**: the field label
      */
    fields: {
      type: Array,
      default: () => []
    },
    serverItemsLength: {
      type: Number,
      default: -1
    },
    /**
      * Array of actions to run on each item
      *
      {
        title: [String],
        method: [function],
        display: [String]
      }
      */
    actions: {
      type: Array,
      default: () => []
    },
    /**
     * Vuetify datatable config object
     */
    config: {
      type: Object,
      default: () => ({})
    },
    /**
     * Vuetify datatable pagination object, used with pagination.sync
     */
    pagination: {
      type: Object,
      default: () => ({})
    },
    /**
     * table loading state
     */
    loading: {
      type: Boolean,
      default: false
    },
    disableSeach: {
      type: Boolean,
      default: false
    },
    /**
     * Vuetify datatable selected items array
     */
    value: {
      type: Array,
      default: () => []
    },
    /**
     * Events array to pass to table
     */
    events: {
      type: Object,
      default: () => ({})
    }
  },
  data: () => ({
    getNested,
    search: "",
    headers: [],
    defaultPagination: {
      totalItems: 0
    }
  }),
  computed: {
    computedPagination: {
      get() {
        return this.hasPagination ? this.pagination : this.defaultPagination;
      },
      set(v) {
        /**
         * pagination sync event
         *
         * @event update:pagination
         * @type {object}
         */
        this.$emit("update:pagination", v);
      }
    },
    computedValue: {
      get() {
        return this.value;
      },
      set(v) {
        this.$emit("input", v);
      }
    },
    computedFields() {
      return this.fields.map(field => {
        return {
          ...field,
          slotName: `item.${field.id}`
        };
      });
    }
  },
  watch: {
    search(v) {
      /**
       * search event
       *
       * @event search
       * @type {object}
       */
      this.$emit("search", v);
    }
  },
  created() {
    this.headers = this.fields.map(field => ({
      text: field.label,
      align: field.align !== undefined ? field.align : "start",
      sortable: field.sortable !== undefined ? field.sortable : true,
      value: field.id
    }));
    if (this.actions && this.actions.length > 0) {
      this.headers.push({
        text: "Actions",
        sortable: false,
        value: "actions"
      });
    } else {
      this.headers.push({
        text: "",
        sortable: false
      });
    }
  },
  methods: {
    hasPagination() {
      const pagination = this.pagination || {};

      return Object.keys(pagination).length > 0;
    }
  }
};
</script>
